## dods.dap
Class DODSException

    java.lang.Object
      java.lang.Throwable
          java.lang.Exception
              dods.dap.DODSException

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  DASException, DDSException, SDODSException

public class DODSException
extends Exception

Holds an exception thrown by DODS server to a client.

Unlike the other DODS exceptions, this one contains extra methods to get the various fields sent by the server, and a `parse` method to parse the `Error` sent from the server.

See Also:
  `DODSException`, Serialized Form

Field Summary
`static int` `CANNOT_READ_FILE` The file specified by the DODS URL can not be read.
`static int` `JAVA_PROGRAM` This Error contains Java bytecode.
`static int` `MALFORMED_EXPR` The expression specified in the DODS URL is not valid.
`static int` `NO_AUTHORIZATION` The user has no authorization to read the DODS URL.
`static int` `NO_PROGRAM` This Error does not contain a program.
`static int` `NO_SUCH_FILE` The file specified by the DODS URL does not exist.
`static int` `NO_SUCH_VARIABLE` The variable specified in the DODS URL does not exist.
`static int` `TCL_PROGRAM` This Error contains TCL code.
`static int` `UNDEFINED_ERROR` Undefined error.
`static int` `UNDEFINED_PROG_TYPE` Undefined program type.
`static int` `UNKNOWN_ERROR` Unknown error.

Fields inherited from class java.lang.Exception
``

Constructor Summary
`DODSException()` Construct an empty `DODSException`.
`DODSException(int code, String msg)` Construct a `DODSException` with the given message.
`DODSException(String msg)` Construct a `DODSException`.

Method Summary
`int` `getErrorCode()` Returns the error code.
`String` `getErrorMessage()` Returns the error message.
`String` `getMessage()` Returns the detail message of this throwable object.
`String` `getProgramSource()` Returns the program source.
`int` `getProgramType()` Returns the program type.
`void` `parse(InputStream is)` Reads an Error description from the named InputStream.
`void` `print(OutputStream os)` Print the Error message on the given `OutputStream`.
`void` `print(PrintWriter os)` Print the Error message on the given `PrintWriter`.
`void` `setErrorCode(int code)` Sets the error code.
`void` `setErrorMessage(String msg)` Sets the error message.
`void` `setProgramSource(String source)` Sets the program source.
`void` `setProgramType(int type)` Sets the program type.

Methods inherited from class java.lang.Throwable
`fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### UNDEFINED_ERROR

    public static final int UNDEFINED_ERROR

  Undefined error.

  See Also:
    Constant Field Values

### UNKNOWN_ERROR

    public static final int UNKNOWN_ERROR

  Unknown error.

  See Also:
    Constant Field Values

### NO_SUCH_FILE

    public static final int NO_SUCH_FILE

  The file specified by the DODS URL does not exist.

  See Also:
    Constant Field Values

### NO_SUCH_VARIABLE

    public static final int NO_SUCH_VARIABLE

  The variable specified in the DODS URL does not exist.

  See Also:
    Constant Field Values

### MALFORMED_EXPR

    public static final int MALFORMED_EXPR

  The expression specified in the DODS URL is not valid.

  See Also:
    Constant Field Values

### NO_AUTHORIZATION

    public static final int NO_AUTHORIZATION

  The user has no authorization to read the DODS URL.

  See Also:
    Constant Field Values

### CANNOT_READ_FILE

    public static final int CANNOT_READ_FILE

  The file specified by the DODS URL can not be read.

  See Also:
    Constant Field Values

### UNDEFINED_PROG_TYPE

    public static final int UNDEFINED_PROG_TYPE

  Undefined program type.

  See Also:
    Constant Field Values

### NO_PROGRAM

    public static final int NO_PROGRAM

  This Error does not contain a program.

  See Also:
    Constant Field Values

### JAVA_PROGRAM

    public static final int JAVA_PROGRAM

  This Error contains Java bytecode.

  See Also:
    Constant Field Values

### TCL_PROGRAM

    public static final int TCL_PROGRAM

  This Error contains TCL code.

  See Also:
    Constant Field Values

Constructor Detail

### DODSException

    public DODSException()

  Construct an empty `DODSException`.

### DODSException

    public DODSException(String msg)

  Construct a `DODSException`.

### DODSException

    public DODSException(int code,
                         String msg)

  Construct a `DODSException` with the given message.

Parameters:
  `code` - the error core
  `msg` - the error message

Method Detail

### getErrorCode

    public final int getErrorCode()

  Returns the error code.

  Returns:
    the error code.

### getErrorMessage

    public final String getErrorMessage()

  Returns the error message.

  Returns:
    the error message.

### getProgramType

    public final int getProgramType()

  Returns the program type.

  Returns:
    the program type.

### getProgramSource

    public final String getProgramSource()

  Returns the program source.

  Returns:
    the program source.

### getMessage

    public String getMessage()

  Returns the detail message of this throwable object.

  Returns:
    the detail message of this throwable object.

### setErrorCode

    public final void setErrorCode(int code)

  Sets the error code.

  Parameters:
    `code` - the error code.

### setErrorMessage

    public final void setErrorMessage(String msg)

  Sets the error message.

  Parameters:
    `msg` - the error message.

### setProgramType

    public final void setProgramType(int type)

  Sets the program type.

  Parameters:
    `type` - the program type.

### setProgramSource

    public final void setProgramSource(String source)

  Sets the program source.

  Parameters:
    `source` - the program source.

### parse

    public final void parse(InputStream is)

  Reads an Error description from the named InputStream. This method calls a generated parser to interpret an ASCII representation of an `Error`, and regenerate it as a `DODSException`.

  Parameters:
    `is` - the InputStream containing the `Error` to parse.
  See Also:
    `ErrorParser`

### print

    public void print(PrintWriter os)

  Print the Error message on the given `PrintWriter`. This code can be used by servlets to throw DODSException to client.

  Parameters:
    `os` - the `PrintWriter` to use for output.

### print

    public final void print(OutputStream os)

  Print the Error message on the given `OutputStream`.

  Parameters:
    `os` - the `OutputStream` to use for output.
  See Also:
    `print(PrintWriter)`